<?php

switch( $lang['lang_short'] ) {
	case 'de':
	case 'en':
	default:
		$lang['newsletter_mail'] = 'Newsletter e-mail';
		$lang['newsletter'] = 'Newsletter';
		$lang['newsletter_subscribe'] = 'Subscribe';
		$lang['newsletter_unsubscribe'] = 'Unsubscribe';
		$lang['newsletter_invalid_mail'] = 'Invalid e-mail address';
		$lang['newsletter_mail_inuse'] = 'This e-mail address is already receiving newsletters';
		$lang['newsletter_mail_notfound'] = 'Coudn\'t activate this e-mail address because the address has not been found, the key is invalid or this e-mail address has already been activated.';
		$lang['newsletter_registered'] = 'Your e-mail address has been registered. A verification e-mail has been sent.';
		$lang['newsletter_mail_confirm'] = "Thank you for subscribing to our newsletter. Please visit the link below to confirm your subscription.\n\n{ACTIVATE_LINK}";
		$lang['newsletter_activated'] = 'You e-mail address has been activated. You will now receive newsletters.';
		$lang['newsletter_unsubscribe_notfound'] = 'email address not found.';
		$lang['newsletter_unsubscribe_invalid'] = 'Coudn\'t unsubscribe because this email is not registered, or this email is inactive or the key is invalid.';
		$lang['newsletter_unsubscribed'] = 'This email address was successfully removed from the newsletter list.';
		$lang['newsletter_mail_unsubscribe'] = "Please visit the link below to unsubscribe from the newsletter.\n\n{UNSUBSCRIBE_LINK}";
		$lang['newsletter_unsubscribe_send'] = 'A confirmation e-mail for unsubscribing from the newsletter list has been sent.';
		$lang['admin_user_right_newsletter'] = 'Newsletter';
		$lang['newsletter_subject'] = 'Subject';
		$lang['newsletter_send'] = 'Newsletters have been sent.';
		$lang['newsletter_send_missing'] = 'Subject or Content missing.';
		$lang['newsletter_mail_footer'] = "\n\n--\nTo unsubscribe visit {UNSUBSCRIBE_LINK}";
		$lang['newsletter_show'] = 'Show e-mail addresses';
		break;
}

define('TABLE_NEWSLETTER', $dbprefix . 'newsletter');

if (!function_exists('qp_encoding')) {
	function qp_encoding($Message) {
		$Message = fixEncoding($Message);
		/* Build (most polpular) Extended ASCII Char/Hex MAP (characters >127 & <255) */
		for ($i=0; $i<127; $i++) {
			$CharList[$i] = "/".chr($i+128)."/";
			$HexList[$i] = "=".strtoupper(bin2hex(chr($i+128)));
		}
	
		/* Encode equal sign & 8-bit characters as equal signs followed by their hexadecimal values */
		$Message = str_replace("=", "=3D", $Message);
		$Message = preg_replace($CharList, $HexList, $Message);
	
		/* Lines longer than 76 characters (size limit for quoted-printable Content-Transfer-Encoding)
			will be cut after character 75 and an equals sign is appended to these lines. */
		$MessageLines = split("\n", $Message);
		$Message_qp = "";
		while(list(, $Line) = each($MessageLines)) {
			if (strlen($Line) > 75) {
				$Pointer = 0;       
				while ($Pointer <= strlen($Line)) {
					$Offset = 0;
					if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+73), 3))) $Offset=-2;
					if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+74), 3))) $Offset=-1;
					$Message_qp.= substr($Line, $Pointer, (75+$Offset))."=\n";
					if ((strlen($Line) - ($Pointer+75)) <= 75) {               
						$Message_qp.= substr($Line, ($Pointer+75+$Offset))."\n";
						break 1;
					}
					$Pointer+= 75+$Offset;
				}
			} else {
				$Message_qp.= $Line."\n";
			}
		}       
		return $Message_qp;
	}
}

if (!function_exists('fixEncoding')) {
// Fixes the encoding to uf8
	function fixEncoding($in_str)
	{
		$cur_encoding = mb_detect_encoding($in_str) ;
		if($cur_encoding == "UTF-8" && mb_check_encoding($in_str,"UTF-8"))
			return $in_str;
		else
			return utf8_encode($in_str);
	} // fixEncoding 
}

function newsletter_admin_settings_check()
{
	global $settings_save;
	if (isset($_POST['newsletter_mail'])) $settings_save['newsletter_mail'] = $_POST['newsletter_mail'];
}

function newsletter_admin_settings_form()
{
	global $config, $tpl, $lang;
	if( !isset( $config['newsletter_mail'] ) ) return;

	$tpl->part_load();
	$tpl->fillin_array( array(
		'S_SETTINGS_FORM' => $lang['newsletter_mail'],
		'I_SETTINGS_FORM' => '<input type="text" name="newsletter_mail" value="' . $config['newsletter_mail'] . '" />',
	) );
}

function newsletter_addsite()
{
	global $site, $config;
	if (checkmail($config['newsletter_mail'])) {
		$site['newsletter'] = './plugins/newsletter/newsletter.php';
	}
}

function newsletter_widget()
{
	global $tpl, $config, $lang;

	if (!checkmail($config['newsletter_mail'])) {
		return;
	}
	
	$tpl->part_load();
	
	$tpl->fillin_array(array(
		'S_SIDEBAR_TITLE' => $lang['newsletter'],
		'S_SIDEBAR_CONTENT' => '<form action="' . url(array('site' => 'newsletter', 'action' => 'subscribe')) . '" method="post">
	<input type="text" name="newsletter_mail" /><br />
	<input style="width:100px" type="submit" name="newsletter_submit" value="' . $lang['newsletter_subscribe'] . '" /><br />
</form>
<a href="' . url(array('site' => 'newsletter', 'action' => 'unsubscribe')) . '">' . $lang['newsletter_unsubscribe'] . '</a><br />&nbsp;',
	));
}

function newsletter_permission()
{
	global $rights;
	$rights[] = 'newsletter';
}

function newsletter_addadminsite()
{
	global $config, $plug, $lang;
	
	if (checkmail($config['newsletter_mail'])) {
		$plug->addadminsite('blog', 'newsletter', './plugins/newsletter/admin.php', $lang['newsletter']);
	}
}

$plug->addhook('hook_admin_user_init', 'newsletter_permission');
$plug->addhook('hook_index_sidebar', 'newsletter_widget', 15);
$plug->addhook('hook_admin_settings_validating', 'newsletter_admin_settings_check');
$plug->addhook('hook_admin_settings_form', 'newsletter_admin_settings_form');
$plug->addhook('hook_index_site_load', 'newsletter_addsite');
$plug->addhook('hook_admin_index_init', 'newsletter_addadminsite');

?>
